#ifndef GITINDEXENTRY_H
#define GITINDEXENTRY_H
// generated from class_header.h
#include <nan.h>
#include <string>

extern "C" {
#include <git2.h>
}

#include "../include/index_time.h"
#include "../include/oid.h"

using namespace node;
using namespace v8;

class GitIndexEntry : public ObjectWrap {
  public:

    static Persistent<Function> constructor_template;
    static void InitializeComponent (Handle<v8::Object> target);

    git_index_entry *GetValue();
    git_index_entry **GetRefValue();

    static Handle<Value> New(void *raw, bool selfFreeing);
    bool selfFreeing;

  private:
    GitIndexEntry(git_index_entry *raw, bool selfFreeing);
    ~GitIndexEntry();

    static NAN_METHOD(JSNewFunction);

    static NAN_METHOD(Ctime);
    static NAN_METHOD(Mtime);
    static NAN_METHOD(Dev);
    static NAN_METHOD(Ino);
    static NAN_METHOD(Mode);
    static NAN_METHOD(Uid);
    static NAN_METHOD(Gid);
    static NAN_METHOD(FileSize);
    static NAN_METHOD(Id);
    static NAN_METHOD(Flags);
    static NAN_METHOD(FlagsExtended);
    static NAN_METHOD(Path);
    git_index_entry *raw;
};

#endif
