var NodeGit = require("../");
NodeGit.Enums = {};

NodeGit.Blame.FLAG = {
  NORMAL: 0,
  TRACK_COPIES_SAME_FILE: 1,
  TRACK_COPIES_SAME_COMMIT_MOVES: 2,
  TRACK_COPIES_SAME_COMMIT_COPIES: 4,
  TRACK_COPIES_ANY_COMMIT_COPIES: 8,
  FIRST_PARENT: 16,
};

NodeGit.Branch.BRANCH = {
  LOCAL: 1,
  REMOTE: 2,
  ALL: 3,
};

NodeGit.Checkout.NOTIFY = {
  NONE: 0,
  CONFLICT: 1,
  DIRTY: 2,
  UPDATED: 4,
  UNTRACKED: 8,
  IGNORED: 16,
  ALL: 65535,
};

NodeGit.Checkout.STRATEGY = {
  NONE: 0,
  SAFE: 1,
  SAFE_CREATE: 2,
  FORCE: 4,
  ALLOW_CONFLICTS: 16,
  REMOVE_UNTRACKED: 32,
  REMOVE_IGNORED: 64,
  UPDATE_ONLY: 128,
  DONT_UPDATE_INDEX: 256,
  NO_REFRESH: 512,
  SKIP_UNMERGED: 1024,
  USE_OURS: 2048,
  USE_THEIRS: 4096,
  DISABLE_PATHSPEC_MATCH: 8192,
  SKIP_LOCKED_DIRECTORIES: 262144,
  DONT_OVERWRITE_IGNORED: 524288,
  CONFLICT_STYLE_MERGE: 1048576,
  CONFLICT_STYLE_DIFF3: 2097152,
  UPDATE_SUBMODULES: 65536,
  UPDATE_SUBMODULES_IF_CHANGED: 131072,
};

NodeGit.Clone.LOCAL = {
  AUTO: 0,
  LOCAL: 1,
  NO_LOCAL: 2,
  NO_LINKS: 3,
};

NodeGit.Config.LEVEL = {
  SYSTEM: 1,
  XDG: 2,
  GLOBAL: 3,
  LOCAL: 4,
  APP: 5,
  HIGHEST_LEVEL: -1,
};

NodeGit.Cred.TYPE = {
  USERPASS_PLAINTEXT: 1,
  SSH_KEY: 2,
  SSH_CUSTOM: 4,
  DEFAULT: 8,
  SSH_INTERACTIVE: 16,
};

NodeGit.Diff.DELTA = {
  UNMODIFIED: 0,
  ADDED: 1,
  DELETED: 2,
  MODIFIED: 3,
  RENAMED: 4,
  COPIED: 5,
  IGNORED: 6,
  UNTRACKED: 7,
  TYPECHANGE: 8,
};

NodeGit.Diff.FIND = {
  BY_CONFIG: 0,
  RENAMES: 1,
  RENAMES_FROM_REWRITES: 2,
  COPIES: 4,
  COPIES_FROM_UNMODIFIED: 8,
  REWRITES: 16,
  BREAK_REWRITES: 32,
  AND_BREAK_REWRITES: 48,
  FOR_UNTRACKED: 64,
  ALL: 255,
  IGNORE_LEADING_WHITESPACE: 0,
  IGNORE_WHITESPACE: 4096,
  DONT_IGNORE_WHITESPACE: 8192,
  EXACT_MATCH_ONLY: 16384,
  BREAK_REWRITES_FOR_RENAMES_ONLY: 32768,
  REMOVE_UNMODIFIED: 65536,
};

NodeGit.Diff.FLAG = {
  BINARY: 1,
  NOT_BINARY: 2,
  VALID_ID: 4,
};

NodeGit.Diff.FORMAT = {
  PATCH: 1,
  PATCH_HEADER: 2,
  RAW: 3,
  NAME_ONLY: 4,
  NAME_STATUS: 5,
};

NodeGit.Diff.FORMAT_EMAIL_FLAGS = {
  FORMAT_EMAIL_NONE: 0,
  FORMAT_EMAIL_EXCLUDE_SUBJECT_PATCH_MARKER: 1,
};

NodeGit.Diff.LINE = {
  CONTEXT: 32,
  ADDITION: 43,
  DELETION: 45,
  CONTEXT_EOFNL: 61,
  ADD_EOFNL: 62,
  DEL_EOFNL: 60,
  FILE_HDR: 70,
  HUNK_HDR: 72,
  BINARY: 66,
};

NodeGit.Diff.OPTION = {
  NORMAL: 0,
  REVERSE: 1,
  INCLUDE_IGNORED: 2,
  RECURSE_IGNORED_DIRS: 4,
  INCLUDE_UNTRACKED: 8,
  RECURSE_UNTRACKED_DIRS: 16,
  INCLUDE_UNMODIFIED: 32,
  INCLUDE_TYPECHANGE: 64,
  INCLUDE_TYPECHANGE_TREES: 128,
  IGNORE_FILEMODE: 256,
  IGNORE_SUBMODULES: 512,
  IGNORE_CASE: 1024,
  DISABLE_PATHSPEC_MATCH: 4096,
  SKIP_BINARY_CHECK: 8192,
  ENABLE_FAST_UNTRACKED_DIRS: 16384,
  UPDATE_INDEX: 32768,
  FORCE_TEXT: 1048576,
  FORCE_BINARY: 2097152,
  IGNORE_WHITESPACE: 4194304,
  IGNORE_WHITESPACE_CHANGE: 8388608,
  IGNORE_WHITESPACE_EOL: 16777216,
  SHOW_UNTRACKED_CONTENT: 33554432,
  SHOW_UNMODIFIED: 67108864,
  PATIENCE: 268435456,
  MINIMAL: 536870912,
  SHOW_BINARY: 1073741824,
};

NodeGit.Diff.STATS_FORMAT = {
  STATS_NONE: 0,
  STATS_FULL: 1,
  STATS_SHORT: 2,
  STATS_NUMBER: 4,
  STATS_INCLUDE_SUMMARY: 8,
};

NodeGit.Enums.DIRECTION = {
  FETCH: 0,
  PUSH: 1,
};

NodeGit.Error.ERROR = {
  GITERR_NONE: 0,
  GITERR_NOMEMORY: 1,
  GITERR_OS: 2,
  GITERR_INVALID: 3,
  GITERR_REFERENCE: 4,
  GITERR_ZLIB: 5,
  GITERR_REPOSITORY: 6,
  GITERR_CONFIG: 7,
  GITERR_REGEX: 8,
  GITERR_ODB: 9,
  GITERR_INDEX: 10,
  GITERR_OBJECT: 11,
  GITERR_NET: 12,
  GITERR_TAG: 13,
  GITERR_TREE: 14,
  GITERR_INDEXER: 15,
  GITERR_SSL: 16,
  GITERR_SUBMODULE: 17,
  GITERR_THREAD: 18,
  GITERR_STASH: 19,
  GITERR_CHECKOUT: 20,
  GITERR_FETCHHEAD: 21,
  GITERR_MERGE: 22,
  GITERR_SSH: 23,
  GITERR_FILTER: 24,
  GITERR_REVERT: 25,
  GITERR_CALLBACK: 26,
  GITERR_CHERRYPICK: 27,
};

NodeGit.Error.CODE = {
  OK: 0,
  ERROR: -1,
  ENOTFOUND: -3,
  EEXISTS: -4,
  EAMBIGUOUS: -5,
  EBUFS: -6,
  EUSER: -7,
  EBAREREPO: -8,
  EUNBORNBRANCH: -9,
  EUNMERGED: -10,
  ENONFASTFORWARD: -11,
  EINVALIDSPEC: -12,
  EMERGECONFLICT: -13,
  ELOCKED: -14,
  EMODIFIED: -15,
  PASSTHROUGH: -30,
  ITEROVER: -31,
};

NodeGit.Enums.FEATURE = {
  THREADS: 1,
  HTTPS: 2,
  SSH: 4,
};

NodeGit.TreeEntry.FILEMODE = {
  NEW: 0,
  TREE: 16384,
  BLOB: 33188,
  EXECUTABLE: 33261,
  LINK: 40960,
  COMMIT: 57344,
};

NodeGit.Filter.MODE = {
  TO_WORKTREE: 0,
  SMUDGE: 0,
  TO_ODB: 1,
  CLEAN: 1,
};

NodeGit.Enums.IDXENTRY_EXTENDED_FLAG = {
  IDXENTRY_INTENT_TO_ADD: 8192,
  IDXENTRY_SKIP_WORKTREE: 16384,
  IDXENTRY_EXTENDED2: 32768,
  S: 24576,
  IDXENTRY_UPDATE: 1,
  IDXENTRY_REMOVE: 2,
  IDXENTRY_UPTODATE: 4,
  IDXENTRY_ADDED: 8,
  IDXENTRY_HASHED: 16,
  IDXENTRY_UNHASHED: 32,
  IDXENTRY_WT_REMOVE: 64,
  IDXENTRY_CONFLICTED: 128,
  IDXENTRY_UNPACKED: 256,
  IDXENTRY_NEW_SKIP_WORKTREE: 512,
};

NodeGit.Index.ADD_OPTION = {
  ADD_DEFAULT: 0,
  ADD_FORCE: 1,
  ADD_DISABLE_PATHSPEC_MATCH: 2,
  ADD_CHECK_PATHSPEC: 4,
};

NodeGit.Index.CAP = {
  IGNORE_CASE: 1,
  NO_FILEMODE: 2,
  NO_SYMLINKS: 4,
  FROM_OWNER: -1,
};

NodeGit.Merge.ANALYSIS = {
  NONE: 0,
  NORMAL: 1,
  UP_TO_DATE: 2,
  FASTFORWARD: 4,
  UNBORN: 8,
};

NodeGit.Merge.FILE_FAVOR = {
  NORMAL: 0,
  OURS: 1,
  THEIRS: 2,
  UNION: 3,
};

NodeGit.Merge.TREE_FLAG = {
  TREE_FIND_RENAMES: 1,
};

NodeGit.Odb.STREAM = {
  RDONLY: 2,
  WRONLY: 4,
  RW: 6,
};

NodeGit.Object.TYPE = {
  ANY: -2,
  BAD: -1,
  EXT1: 0,
  COMMIT: 1,
  TREE: 2,
  BLOB: 3,
  TAG: 4,
  EXT2: 5,
  OFS_DELTA: 6,
  REF_DELTA: 7,
};

NodeGit.Packbuilder.STAGE = {
  ADDING_OBJECTS: 0,
  DELTAFICATION: 1,
};

NodeGit.Pathspec.FLAG = {
  DEFAULT: 0,
  IGNORE_CASE: 1,
  USE_CASE: 2,
  NO_GLOB: 4,
  NO_MATCH_ERROR: 8,
  FIND_FAILURES: 16,
  FAILURES_ONLY: 32,
};

NodeGit.Reference.TYPE = {
  INVALID: 0,
  OID: 1,
  SYMBOLIC: 2,
  LISTALL: 3,
};

NodeGit.Remote.COMPLETION_TYPE = {
  COMPLETION_DOWNLOAD: 0,
  COMPLETION_INDEXING: 1,
  COMPLETION_ERROR: 2,
};

NodeGit.Repository.INIT_FLAG = {
  BARE: 1,
  NO_REINIT: 2,
  NO_DOTGIT_DIR: 4,
  MKDIR: 8,
  MKPATH: 16,
  EXTERNAL_TEMPLATE: 32,
};

NodeGit.Repository.INIT_MODE = {
  INIT_SHARED_UMASK: 0,
  INIT_SHARED_GROUP: 1533,
  INIT_SHARED_ALL: 1535,
};

NodeGit.Repository.OPEN_FLAG = {
  OPEN_NO_SEARCH: 1,
  OPEN_CROSS_FS: 2,
  OPEN_BARE: 4,
};

NodeGit.Revparse.MODE = {
  SINGLE: 1,
  RANGE: 2,
  MERGE_BASE: 4,
};

NodeGit.Revwalk.SORT = {
  NONE: 0,
  TOPOLOGICAL: 1,
  TIME: 2,
  REVERSE: 4,
};

NodeGit.Stash.FLAGS = {
  DEFAULT: 0,
  KEEP_INDEX: 1,
  INCLUDE_UNTRACKED: 2,
  INCLUDE_IGNORED: 4,
};

NodeGit.Status.STATUS = {
  CURRENT: 0,
  INDEX_NEW: 1,
  INDEX_MODIFIED: 2,
  INDEX_DELETED: 4,
  INDEX_RENAMED: 8,
  INDEX_TYPECHANGE: 16,
  WT_NEW: 128,
  WT_MODIFIED: 256,
  WT_DELETED: 512,
  WT_TYPECHANGE: 1024,
  WT_RENAMED: 2048,
  IGNORED: 16384,
};

NodeGit.Status.OPT = {
  INCLUDE_UNTRACKED: 1,
  INCLUDE_IGNORED: 2,
  INCLUDE_UNMODIFIED: 4,
  EXCLUDE_SUBMODULES: 8,
  RECURSE_UNTRACKED_DIRS: 16,
  DISABLE_PATHSPEC_MATCH: 32,
  RECURSE_IGNORED_DIRS: 64,
  RENAMES_HEAD_TO_INDEX: 128,
  RENAMES_INDEX_TO_WORKDIR: 256,
  SORT_CASE_SENSITIVELY: 512,
  SORT_CASE_INSENSITIVELY: 1024,
  RENAMES_FROM_REWRITES: 2048,
  NO_REFRESH: 4096,
  UPDATE_INDEX: 8192,
};

NodeGit.Status.SHOW = {
  INDEX_AND_WORKDIR: 0,
  INDEX_ONLY: 1,
  WORKDIR_ONLY: 2,
};

NodeGit.Submodule.IGNORE = {
  RESET: -1,
  NONE: 1,
  UNTRACKED: 2,
  DIRTY: 3,
  ALL: 4,
  DEFAULT: 0,
};

NodeGit.Submodule.RECURSE = {
  RESET: -1,
  NO: 0,
  YES: 1,
  ONDEMAND: 2,
};

NodeGit.Submodule.STATUS = {
  IN_HEAD: 1,
  IN_INDEX: 2,
  IN_CONFIG: 4,
  IN_WD: 8,
  INDEX_ADDED: 16,
  INDEX_DELETED: 32,
  INDEX_MODIFIED: 64,
  WD_UNINITIALIZED: 128,
  WD_ADDED: 256,
  WD_DELETED: 512,
  WD_MODIFIED: 1024,
  WD_INDEX_MODIFIED: 2048,
  WD_WD_MODIFIED: 4096,
  WD_UNTRACKED: 8192,
};

NodeGit.Submodule.UPDATE = {
  RESET: -1,
  CHECKOUT: 1,
  REBASE: 2,
  MERGE: 3,
  NONE: 4,
  DEFAULT: 0,
};

NodeGit.Trace.LEVEL = {
  NONE: 0,
  FATAL: 1,
  ERROR: 2,
  WARN: 3,
  INFO: 4,
  DEBUG: 5,
  TRACE: 6,
};

NodeGit.Tree.WALK_MODE = {
  WALK_PRE: 0,
  WALK_POST: 1,
};