{
  # Copyright (c) 2012 The Chromium Authors. All rights reserved.
  # Use of this source code is governed by a BSD-style license that can be
  # found in the LICENSE file.
  "variables": {
    "target_arch%": "x86",
    "library%": "static_library",
    "openssl_enable_asm%": 0, # only supported with the Visual Studio 2012 (VC11) toolchain.
    "gcc_version%": 0,
    "is_clang%": 0,
  },
  "targets": [
    {
      "target_name": "libgit2",
      "type": "static_library",
      "defines": [
        "GIT_THREADS",
        "GIT_SSH",
        # Node's util.h may be accidentally included so use this to guard
        # against compilation error.
        "SRC_UTIL_H_",
      ],
      "dependencies": [
        "zlib",
        "<(module_root_dir)/vendor/http_parser/http_parser.gyp:http_parser",
        "libssh2",
        "openssl"
      ],
      "sources": [
        "libgit2/src/array.h",
        "libgit2/src/attr.c",
        "libgit2/src/attr.h",
        "libgit2/src/attr_file.c",
        "libgit2/src/attr_file.h",
        "libgit2/src/attrcache.c",
        "libgit2/src/attrcache.h",
        "libgit2/src/bitvec.h",
        "libgit2/src/blame.c",
        "libgit2/src/blame.h",
        "libgit2/src/blame_git.c",
        "libgit2/src/blame_git.h",
        "libgit2/src/blob.c",
        "libgit2/src/blob.h",
        "libgit2/src/branch.c",
        "libgit2/src/branch.h",
        "libgit2/src/bswap.h",
        "libgit2/src/buf_text.c",
        "libgit2/src/buf_text.h",
        "libgit2/src/buffer.c",
        "libgit2/src/buffer.h",
        "libgit2/src/cache.c",
        "libgit2/src/cache.h",
        "libgit2/src/cc-compat.h",
        "libgit2/src/checkout.c",
        "libgit2/src/checkout.h",
        "libgit2/src/cherrypick.c",
        "libgit2/src/clone.c",
        "libgit2/src/clone.h",
        "libgit2/src/commit.c",
        "libgit2/src/commit.h",
        "libgit2/src/commit_list.c",
        "libgit2/src/commit_list.h",
        "libgit2/src/common.h",
        "libgit2/src/config.c",
        "libgit2/src/config.h",
        "libgit2/src/config_cache.c",
        "libgit2/src/config_file.c",
        "libgit2/src/config_file.h",
        "libgit2/src/crlf.c",
        "libgit2/src/date.c",
        "libgit2/src/delta-apply.c",
        "libgit2/src/delta-apply.h",
        "libgit2/src/delta.c",
        "libgit2/src/delta.h",
        "libgit2/src/diff.c",
        "libgit2/src/diff.h",
        "libgit2/src/diff_driver.c",
        "libgit2/src/diff_driver.h",
        "libgit2/src/diff_file.c",
        "libgit2/src/diff_file.h",
        "libgit2/src/diff_patch.c",
        "libgit2/src/diff_patch.h",
        "libgit2/src/diff_print.c",
        "libgit2/src/diff_stats.c",
        "libgit2/src/diff_tform.c",
        "libgit2/src/diff_xdiff.c",
        "libgit2/src/diff_xdiff.h",
        "libgit2/src/errors.c",
        "libgit2/src/fetch.c",
        "libgit2/src/fetch.h",
        "libgit2/src/fetchhead.c",
        "libgit2/src/fetchhead.h",
        "libgit2/src/filebuf.c",
        "libgit2/src/filebuf.h",
        "libgit2/src/fileops.c",
        "libgit2/src/fileops.h",
        "libgit2/src/filter.c",
        "libgit2/src/filter.h",
        "libgit2/src/fnmatch.c",
        "libgit2/src/fnmatch.h",
        "libgit2/src/global.c",
        "libgit2/src/global.h",
        "libgit2/src/graph.c",
        "libgit2/src/hash.c",
        "libgit2/src/hash.h",
        "libgit2/src/hashsig.c",
        "libgit2/src/hashsig.h",
        "libgit2/src/ident.c",
        "libgit2/src/ignore.c",
        "libgit2/src/ignore.h",
        "libgit2/src/index.c",
        "libgit2/src/index.h",
        "libgit2/src/indexer.c",
        "libgit2/src/iterator.c",
        "libgit2/src/iterator.h",
        "libgit2/src/khash.h",
        "libgit2/src/map.h",
        "libgit2/src/merge.c",
        "libgit2/src/merge.h",
        "libgit2/src/merge_file.c",
        "libgit2/src/merge_file.h",
        "libgit2/src/message.c",
        "libgit2/src/message.h",
        "libgit2/src/mwindow.c",
        "libgit2/src/mwindow.h",
        "libgit2/src/netops.c",
        "libgit2/src/netops.h",
        "libgit2/src/notes.c",
        "libgit2/src/notes.h",
        "libgit2/src/object.c",
        "libgit2/src/object.h",
        "libgit2/src/object_api.c",
        "libgit2/src/odb.c",
        "libgit2/src/odb.h",
        "libgit2/src/odb_loose.c",
        "libgit2/src/odb_mempack.c",
        "libgit2/src/odb_pack.c",
        "libgit2/src/offmap.h",
        "libgit2/src/oid.c",
        "libgit2/src/oid.h",
        "libgit2/src/oidmap.h",
        "libgit2/src/pack-objects.c",
        "libgit2/src/pack-objects.h",
        "libgit2/src/pack.c",
        "libgit2/src/pack.h",
        "libgit2/src/path.c",
        "libgit2/src/path.h",
        "libgit2/src/pathspec.c",
        "libgit2/src/pathspec.h",
        "libgit2/src/pool.c",
        "libgit2/src/pool.h",
        "libgit2/src/posix.c",
        "libgit2/src/posix.h",
        "libgit2/src/pqueue.c",
        "libgit2/src/pqueue.h",
        "libgit2/src/push.c",
        "libgit2/src/push.h",
        "libgit2/src/refdb.c",
        "libgit2/src/refdb.h",
        "libgit2/src/refdb_fs.c",
        "libgit2/src/refdb_fs.h",
        "libgit2/src/reflog.c",
        "libgit2/src/reflog.h",
        "libgit2/src/refs.c",
        "libgit2/src/refs.h",
        "libgit2/src/refspec.c",
        "libgit2/src/refspec.h",
        "libgit2/src/remote.c",
        "libgit2/src/remote.h",
        "libgit2/src/repo_template.h",
        "libgit2/src/repository.c",
        "libgit2/src/repository.h",
        "libgit2/src/reset.c",
        "libgit2/src/revert.c",
        "libgit2/src/revparse.c",
        "libgit2/src/revwalk.c",
        "libgit2/src/revwalk.h",
        "libgit2/src/settings.c",
        "libgit2/src/sha1_lookup.c",
        "libgit2/src/sha1_lookup.h",
        "libgit2/src/signature.c",
        "libgit2/src/signature.h",
        "libgit2/src/sortedcache.c",
        "libgit2/src/sortedcache.h",
        "libgit2/src/stash.c",
        "libgit2/src/status.c",
        "libgit2/src/status.h",
        "libgit2/src/strmap.c",
        "libgit2/src/strmap.h",
        "libgit2/src/strnlen.h",
        "libgit2/src/submodule.c",
        "libgit2/src/submodule.h",
        "libgit2/src/sysdir.c",
        "libgit2/src/sysdir.h",
        "libgit2/src/tag.c",
        "libgit2/src/tag.h",
        "libgit2/src/thread-utils.c",
        "libgit2/src/thread-utils.h",
        "libgit2/src/trace.c",
        "libgit2/src/trace.h",
        "libgit2/src/transport.c",
        "libgit2/src/tree-cache.c",
        "libgit2/src/tree-cache.h",
        "libgit2/src/tree.c",
        "libgit2/src/tree.h",
        "libgit2/src/tsort.c",
        "libgit2/src/userdiff.h",
        "libgit2/src/util.c",
        "libgit2/src/util.h",
        "libgit2/src/vector.c",
        "libgit2/src/vector.h",
        "libgit2/src/zstream.c",
        "libgit2/src/zstream.h",
        "libgit2/src/hash/hash_generic.c",
        "libgit2/src/hash/hash_generic.h",
        "libgit2/src/hash/hash_openssl.h",
        "libgit2/src/transports/cred.c",
        "libgit2/src/transports/cred_helpers.c",
        "libgit2/src/transports/git.c",
        "libgit2/src/transports/http.c",
        "libgit2/src/transports/local.c",
        "libgit2/src/transports/smart.c",
        "libgit2/src/transports/smart.h",
        "libgit2/src/transports/smart_pkt.c",
        "libgit2/src/transports/smart_protocol.c",
        "libgit2/src/transports/ssh.c",
        "libgit2/src/xdiff/xdiff.h",
        "libgit2/src/xdiff/xdiffi.c",
        "libgit2/src/xdiff/xdiffi.h",
        "libgit2/src/xdiff/xemit.c",
        "libgit2/src/xdiff/xemit.h",
        "libgit2/src/xdiff/xhistogram.c",
        "libgit2/src/xdiff/xinclude.h",
        "libgit2/src/xdiff/xmacros.h",
        "libgit2/src/xdiff/xmerge.c",
        "libgit2/src/xdiff/xpatience.c",
        "libgit2/src/xdiff/xprepare.c",
        "libgit2/src/xdiff/xprepare.h",
        "libgit2/src/xdiff/xtypes.h",
        "libgit2/src/xdiff/xutils.c",
        "libgit2/src/xdiff/xutils.h",
      ],
      "conditions": [
        ["OS!='win'", {
            "defines": [
                "GIT_SSL"
            ],
        }],
        ["OS=='win'", {}, {
          "sources": [
            "libgit2/src/unix/map.c",
            "libgit2/src/unix/posix.h",
            "libgit2/src/unix/realpath.c",
          ]
        }],
        ["OS=='linux'", {
          "cflags": [
            "-DGIT_SSH",
            "-DGIT_SSL",
            "-w",
          ],
        }],
        ["OS=='win'", {
          "defines": [
            "GIT_WINHTTP",
          ],
          "msvs_settings": {
            "VCLinkerTool": {
              "AdditionalDependencies": [
                "ws2_32.lib",
              ],
            },
            # Workaround of a strange bug:
            # TargetMachine + static_library + x64 = nothing.
            "conditions": [
              ["target_arch=='x64'", {
                "VCLibrarianTool": {
                  "AdditionalOptions": [
                    "/MACHINE:X64",
                  ],
                },
              }, {
                "VCLibrarianTool": {
                  "AdditionalOptions": [
                    "/MACHINE:x86",
                  ],
                },
              }],
            ],
          },
          "msvs_disabled_warnings": [
            # Conversion from 'ssize_t' to 'int32_t', possible loss of data.
            4244,
            # Conversion from 'size_t' to 'int', possible loss of data.
            4267,
            # Different 'volatile' qualifiers.
            4090,
            # 'volatile void *' differs in levels of indirection from 'int'.
            4047,
            # 'InterlockedDecrement' undefined; assuming extern returning int.
            4013,
          ],
          "sources": [
            "libgit2/src/win32/dir.c",
            "libgit2/src/win32/dir.h",
            "libgit2/src/win32/error.c",
            "libgit2/src/win32/error.h",
            "libgit2/src/win32/findfile.c",
            "libgit2/src/win32/findfile.h",
            "libgit2/src/win32/git2.rc",
            "libgit2/src/win32/map.c",
            "libgit2/src/win32/mingw-compat.h",
            "libgit2/src/win32/msvc-compat.h",
            "libgit2/src/win32/posix.h",
            "libgit2/src/win32/posix_w32.c",
            "libgit2/src/win32/precompiled.c",
            "libgit2/src/win32/precompiled.h",
            "libgit2/src/win32/pthread.c",
            "libgit2/src/win32/pthread.h",
            "libgit2/src/win32/reparse.h",
            "libgit2/src/win32/utf-conv.c",
            "libgit2/src/win32/utf-conv.h",
            "libgit2/src/win32/version.h",
            "libgit2/src/win32/w32_util.c",
            "libgit2/src/win32/w32_util.h",
            "libgit2/src/win32/path_w32.c",
            "libgit2/src/win32/path_w32.h",
            "libgit2/src/transports/winhttp.c",
            "libgit2/deps/regex/regex.c",
          ],
        }, {
          "libraries": [
            "-lpthread",
          ],
          "sources": [
            "libgit2/src/unix/map.c",
            "libgit2/src/unix/posix.h",
            "libgit2/src/unix/realpath.c",
          ],
          "cflags": [
            "-Wno-missing-field-initializers",
            "-Wno-unused-variable",
            "-Wno-deprecated-declarations",
          ],
          "xcode_settings": {
            "WARNING_CFLAGS": [
              "-Wno-missing-field-initializers",
              "-Wno-unused-variable",
              "-Wno-deprecated-declarations",
              "-Wno-uninitialized",
            ],
          },
        },
      ]
      ],
      "include_dirs": [
        "libgit2/include",
        "libgit2/src",
        "libgit2/deps/regex"
      ],
      "direct_dependent_settings": {
        "include_dirs": [
          "libgit2/include",
        ],
      },
    },
    {
      "target_name": "zlib",
      "type": "static_library",
      "sources": [
        "libgit2/deps/zlib/adler32.c",
        "libgit2/deps/zlib/crc32.c",
        "libgit2/deps/zlib/crc32.h",
        "libgit2/deps/zlib/deflate.c",
        "libgit2/deps/zlib/deflate.h",
        "libgit2/deps/zlib/inffast.c",
        "libgit2/deps/zlib/inffast.h",
        "libgit2/deps/zlib/inffixed.h",
        "libgit2/deps/zlib/inflate.c",
        "libgit2/deps/zlib/inflate.h",
        "libgit2/deps/zlib/inftrees.c",
        "libgit2/deps/zlib/inftrees.h",
        "libgit2/deps/zlib/trees.c",
        "libgit2/deps/zlib/trees.h",
        "libgit2/deps/zlib/zconf.h",
        "libgit2/deps/zlib/zlib.h",
        "libgit2/deps/zlib/zutil.c",
        "libgit2/deps/zlib/zutil.h",
      ],
      "defines": [
        "NO_VIZ",
        "STDC",
        "NO_GZIP",
      ],
      "include_dirs": [
        "libgit2/include",
        "libgit2/deps/regex",
      ],
      "direct_dependent_settings": {
        "include_dirs": [
          "libgit2/deps/zlib",
        ],
      },
    },
    {
      "target_name": "libssh2",
      "type": "static_library",
      "defines": [
        "NETSNMP_ENABLE_IPV6"
      ],
      "sources": [
        "libssh2/src/agent.c",
        "libssh2/src/crypt.c",
        "libssh2/src/keepalive.c",
        "libssh2/src/libgcrypt.c",
        "libssh2/src/openssl.c",
        "libssh2/src/publickey.c",
        "libssh2/src/sftp.c",
        "libssh2/src/version.c",
        "libssh2/src/channel.c",
        "libssh2/src/global.c",
        "libssh2/src/kex.c",
        "libssh2/src/mac.c",
        "libssh2/src/packet.c",
        "libssh2/src/scp.c",
        "libssh2/src/transport.c",
        "libssh2/src/comp.c",
        "libssh2/src/hostkey.c",
        "libssh2/src/knownhost.c",
        "libssh2/src/misc.c",
        "libssh2/src/pem.c",
        "libssh2/src/session.c",
        "libssh2/src/userauth.c",
      ],
      "include_dirs": [
        ".",
        "libssh2/include",
      ],
      "dependencies": [
        "openssl"
      ],
      "direct_dependent_settings": {
        "include_dirs": [
          "libssh2/include"
        ]
      },
      "conditions": [
        ["OS=='win'", {
          "include_dirs": [
            "libssh2/src",
            "libssh2/win32",
            "libssh2/include"
          ],
          "direct_dependent_settings": {
            "include_dirs": [
              "libssh2/src",
              "libssh2/win32",
              "libssh2/include"
            ]
          }
        }],
      ]
    },
    {
      "target_name": "openssl",
      "type": "static_library",
      "defines": [
        #No clue what these are for.
        "L_ENDIAN",
        "PURIFY",
        "_REENTRANT",
        "NO_WINDOWS_BRAINDEATH",
      ],
      "include_dirs": [
        ".",
        "openssl/openssl",
        "openssl/openssl/crypto",
        "openssl/openssl/crypto/asn1",
        "openssl/openssl/crypto/evp",
        "openssl/openssl/crypto/md2",
        "openssl/openssl/crypto/modes",
        "openssl/openssl/crypto/store",
        "openssl/openssl/include",
      ],
      "direct_dependent_settings": {
        "include_dirs": [
           "openssl/openssl/include",
           "openssl/openssl/include/openssl",
        ]
      },
      "sources": [
        "openssl/openssl/ssl/bio_ssl.c",
        "openssl/openssl/ssl/d1_both.c",
        "openssl/openssl/ssl/d1_clnt.c",
        "openssl/openssl/ssl/d1_enc.c",
        "openssl/openssl/ssl/d1_lib.c",
        "openssl/openssl/ssl/d1_meth.c",
        "openssl/openssl/ssl/d1_pkt.c",
        "openssl/openssl/ssl/d1_srtp.c",
        "openssl/openssl/ssl/d1_srvr.c",
        "openssl/openssl/ssl/kssl.c",
        "openssl/openssl/ssl/s23_clnt.c",
        "openssl/openssl/ssl/s23_lib.c",
        "openssl/openssl/ssl/s23_meth.c",
        "openssl/openssl/ssl/s23_pkt.c",
        "openssl/openssl/ssl/s23_srvr.c",
        "openssl/openssl/ssl/s2_clnt.c",
        "openssl/openssl/ssl/s2_enc.c",
        "openssl/openssl/ssl/s2_lib.c",
        "openssl/openssl/ssl/s2_meth.c",
        "openssl/openssl/ssl/s2_pkt.c",
        "openssl/openssl/ssl/s2_srvr.c",
        "openssl/openssl/ssl/s3_both.c",
        "openssl/openssl/ssl/s3_clnt.c",
        "openssl/openssl/ssl/s3_enc.c",
        "openssl/openssl/ssl/s3_lib.c",
        "openssl/openssl/ssl/s3_meth.c",
        "openssl/openssl/ssl/s3_pkt.c",
        "openssl/openssl/ssl/s3_srvr.c",
        "openssl/openssl/ssl/s3_cbc.c",
        "openssl/openssl/ssl/ssl_algs.c",
        "openssl/openssl/ssl/ssl_asn1.c",
        "openssl/openssl/ssl/ssl_cert.c",
        "openssl/openssl/ssl/ssl_ciph.c",
        "openssl/openssl/ssl/ssl_err.c",
        "openssl/openssl/ssl/ssl_err2.c",
        "openssl/openssl/ssl/ssl_lib.c",
        "openssl/openssl/ssl/ssl_rsa.c",
        "openssl/openssl/ssl/ssl_sess.c",
        "openssl/openssl/ssl/ssl_stat.c",
        "openssl/openssl/ssl/ssl_txt.c",
        "openssl/openssl/ssl/t1_clnt.c",
        "openssl/openssl/ssl/t1_enc.c",
        "openssl/openssl/ssl/t1_lib.c",
        "openssl/openssl/ssl/t1_meth.c",
        "openssl/openssl/ssl/t1_reneg.c",
        "openssl/openssl/ssl/t1_srvr.c",
        "openssl/openssl/ssl/tls_srp.c",
        "openssl/openssl/crypto/aes/aes_cfb.c",
        "openssl/openssl/crypto/aes/aes_ctr.c",
        "openssl/openssl/crypto/aes/aes_ecb.c",
        "openssl/openssl/crypto/aes/aes_ige.c",
        "openssl/openssl/crypto/aes/aes_misc.c",
        "openssl/openssl/crypto/aes/aes_ofb.c",
        "openssl/openssl/crypto/aes/aes_wrap.c",
        "openssl/openssl/crypto/asn1/a_bitstr.c",
        "openssl/openssl/crypto/asn1/a_bool.c",
        "openssl/openssl/crypto/asn1/a_bytes.c",
        "openssl/openssl/crypto/asn1/a_d2i_fp.c",
        "openssl/openssl/crypto/asn1/a_digest.c",
        "openssl/openssl/crypto/asn1/a_dup.c",
        "openssl/openssl/crypto/asn1/a_enum.c",
        "openssl/openssl/crypto/asn1/a_gentm.c",
        "openssl/openssl/crypto/asn1/a_i2d_fp.c",
        "openssl/openssl/crypto/asn1/a_int.c",
        "openssl/openssl/crypto/asn1/a_mbstr.c",
        "openssl/openssl/crypto/asn1/a_object.c",
        "openssl/openssl/crypto/asn1/a_octet.c",
        "openssl/openssl/crypto/asn1/a_print.c",
        "openssl/openssl/crypto/asn1/a_set.c",
        "openssl/openssl/crypto/asn1/a_sign.c",
        "openssl/openssl/crypto/asn1/a_strex.c",
        "openssl/openssl/crypto/asn1/a_strnid.c",
        "openssl/openssl/crypto/asn1/a_time.c",
        "openssl/openssl/crypto/asn1/a_type.c",
        "openssl/openssl/crypto/asn1/a_utctm.c",
        "openssl/openssl/crypto/asn1/a_utf8.c",
        "openssl/openssl/crypto/asn1/a_verify.c",
        "openssl/openssl/crypto/asn1/ameth_lib.c",
        "openssl/openssl/crypto/asn1/asn1_err.c",
        "openssl/openssl/crypto/asn1/asn1_gen.c",
        "openssl/openssl/crypto/asn1/asn1_lib.c",
        "openssl/openssl/crypto/asn1/asn1_par.c",
        "openssl/openssl/crypto/asn1/asn_mime.c",
        "openssl/openssl/crypto/asn1/asn_moid.c",
        "openssl/openssl/crypto/asn1/asn_pack.c",
        "openssl/openssl/crypto/asn1/bio_asn1.c",
        "openssl/openssl/crypto/asn1/bio_ndef.c",
        "openssl/openssl/crypto/asn1/d2i_pr.c",
        "openssl/openssl/crypto/asn1/d2i_pu.c",
        "openssl/openssl/crypto/asn1/evp_asn1.c",
        "openssl/openssl/crypto/asn1/f_enum.c",
        "openssl/openssl/crypto/asn1/f_int.c",
        "openssl/openssl/crypto/asn1/f_string.c",
        "openssl/openssl/crypto/asn1/i2d_pr.c",
        "openssl/openssl/crypto/asn1/i2d_pu.c",
        "openssl/openssl/crypto/asn1/n_pkey.c",
        "openssl/openssl/crypto/asn1/nsseq.c",
        "openssl/openssl/crypto/asn1/p5_pbe.c",
        "openssl/openssl/crypto/asn1/p5_pbev2.c",
        "openssl/openssl/crypto/asn1/p8_pkey.c",
        "openssl/openssl/crypto/asn1/t_bitst.c",
        "openssl/openssl/crypto/asn1/t_crl.c",
        "openssl/openssl/crypto/asn1/t_pkey.c",
        "openssl/openssl/crypto/asn1/t_req.c",
        "openssl/openssl/crypto/asn1/t_spki.c",
        "openssl/openssl/crypto/asn1/t_x509.c",
        "openssl/openssl/crypto/asn1/t_x509a.c",
        "openssl/openssl/crypto/asn1/tasn_dec.c",
        "openssl/openssl/crypto/asn1/tasn_enc.c",
        "openssl/openssl/crypto/asn1/tasn_fre.c",
        "openssl/openssl/crypto/asn1/tasn_new.c",
        "openssl/openssl/crypto/asn1/tasn_prn.c",
        "openssl/openssl/crypto/asn1/tasn_typ.c",
        "openssl/openssl/crypto/asn1/tasn_utl.c",
        "openssl/openssl/crypto/asn1/x_algor.c",
        "openssl/openssl/crypto/asn1/x_attrib.c",
        "openssl/openssl/crypto/asn1/x_bignum.c",
        "openssl/openssl/crypto/asn1/x_crl.c",
        "openssl/openssl/crypto/asn1/x_exten.c",
        "openssl/openssl/crypto/asn1/x_info.c",
        "openssl/openssl/crypto/asn1/x_long.c",
        "openssl/openssl/crypto/asn1/x_name.c",
        "openssl/openssl/crypto/asn1/x_nx509.c",
        "openssl/openssl/crypto/asn1/x_pkey.c",
        "openssl/openssl/crypto/asn1/x_pubkey.c",
        "openssl/openssl/crypto/asn1/x_req.c",
        "openssl/openssl/crypto/asn1/x_sig.c",
        "openssl/openssl/crypto/asn1/x_spki.c",
        "openssl/openssl/crypto/asn1/x_val.c",
        "openssl/openssl/crypto/asn1/x_x509.c",
        "openssl/openssl/crypto/asn1/x_x509a.c",
        "openssl/openssl/crypto/bf/bf_cfb64.c",
        "openssl/openssl/crypto/bf/bf_ecb.c",
        "openssl/openssl/crypto/bf/bf_ofb64.c",
        "openssl/openssl/crypto/bf/bf_skey.c",
        "openssl/openssl/crypto/bio/b_dump.c",
        "openssl/openssl/crypto/bio/b_print.c",
        "openssl/openssl/crypto/bio/b_sock.c",
        "openssl/openssl/crypto/bio/bf_buff.c",
        "openssl/openssl/crypto/bio/bf_nbio.c",
        "openssl/openssl/crypto/bio/bf_null.c",
        "openssl/openssl/crypto/bio/bio_cb.c",
        "openssl/openssl/crypto/bio/bio_err.c",
        "openssl/openssl/crypto/bio/bio_lib.c",
        "openssl/openssl/crypto/bio/bss_acpt.c",
        "openssl/openssl/crypto/bio/bss_bio.c",
        "openssl/openssl/crypto/bio/bss_conn.c",
        "openssl/openssl/crypto/bio/bss_dgram.c",
        "openssl/openssl/crypto/bio/bss_fd.c",
        "openssl/openssl/crypto/bio/bss_file.c",
        "openssl/openssl/crypto/bio/bss_log.c",
        "openssl/openssl/crypto/bio/bss_mem.c",
        "openssl/openssl/crypto/bio/bss_null.c",
        "openssl/openssl/crypto/bio/bss_sock.c",
        "openssl/openssl/crypto/bn/bn_add.c",
        "openssl/openssl/crypto/bn/bn_blind.c",
        "openssl/openssl/crypto/bn/bn_const.c",
        "openssl/openssl/crypto/bn/bn_ctx.c",
        "openssl/openssl/crypto/bn/bn_depr.c",
        "openssl/openssl/crypto/bn/bn_div.c",
        "openssl/openssl/crypto/bn/bn_err.c",
        "openssl/openssl/crypto/bn/bn_exp.c",
        "openssl/openssl/crypto/bn/bn_exp2.c",
        "openssl/openssl/crypto/bn/bn_gcd.c",
        "openssl/openssl/crypto/bn/bn_gf2m.c",
        "openssl/openssl/crypto/bn/bn_kron.c",
        "openssl/openssl/crypto/bn/bn_lib.c",
        "openssl/openssl/crypto/bn/bn_mod.c",
        "openssl/openssl/crypto/bn/bn_mont.c",
        "openssl/openssl/crypto/bn/bn_mpi.c",
        "openssl/openssl/crypto/bn/bn_mul.c",
        "openssl/openssl/crypto/bn/bn_nist.c",
        "openssl/openssl/crypto/bn/bn_prime.c",
        "openssl/openssl/crypto/bn/bn_print.c",
        "openssl/openssl/crypto/bn/bn_rand.c",
        "openssl/openssl/crypto/bn/bn_recp.c",
        "openssl/openssl/crypto/bn/bn_shift.c",
        "openssl/openssl/crypto/bn/bn_sqr.c",
        "openssl/openssl/crypto/bn/bn_sqrt.c",
        "openssl/openssl/crypto/bn/bn_word.c",
        "openssl/openssl/crypto/bn/bn_x931p.c",
        "openssl/openssl/crypto/buffer/buf_err.c",
        "openssl/openssl/crypto/buffer/buf_str.c",
        "openssl/openssl/crypto/buffer/buffer.c",
        "openssl/openssl/crypto/camellia/cmll_cfb.c",
        "openssl/openssl/crypto/camellia/cmll_ctr.c",
        "openssl/openssl/crypto/camellia/cmll_ecb.c",
        "openssl/openssl/crypto/camellia/cmll_ofb.c",
        "openssl/openssl/crypto/camellia/cmll_utl.c",
        "openssl/openssl/crypto/cast/c_cfb64.c",
        "openssl/openssl/crypto/cast/c_ecb.c",
        "openssl/openssl/crypto/cast/c_ofb64.c",
        "openssl/openssl/crypto/cast/c_skey.c",
        "openssl/openssl/crypto/cmac/cm_ameth.c",
        "openssl/openssl/crypto/cmac/cm_pmeth.c",
        "openssl/openssl/crypto/cmac/cmac.c",
        "openssl/openssl/crypto/cms/cms_asn1.c",
        "openssl/openssl/crypto/cms/cms_att.c",
        "openssl/openssl/crypto/cms/cms_cd.c",
        "openssl/openssl/crypto/cms/cms_dd.c",
        "openssl/openssl/crypto/cms/cms_enc.c",
        "openssl/openssl/crypto/cms/cms_env.c",
        "openssl/openssl/crypto/cms/cms_err.c",
        "openssl/openssl/crypto/cms/cms_ess.c",
        "openssl/openssl/crypto/cms/cms_io.c",
        "openssl/openssl/crypto/cms/cms_lib.c",
        "openssl/openssl/crypto/cms/cms_pwri.c",
        "openssl/openssl/crypto/cms/cms_sd.c",
        "openssl/openssl/crypto/cms/cms_smime.c",
        "openssl/openssl/crypto/comp/c_rle.c",
        "openssl/openssl/crypto/comp/c_zlib.c",
        "openssl/openssl/crypto/comp/comp_err.c",
        "openssl/openssl/crypto/comp/comp_lib.c",
        "openssl/openssl/crypto/conf/conf_api.c",
        "openssl/openssl/crypto/conf/conf_def.c",
        "openssl/openssl/crypto/conf/conf_err.c",
        "openssl/openssl/crypto/conf/conf_lib.c",
        "openssl/openssl/crypto/conf/conf_mall.c",
        "openssl/openssl/crypto/conf/conf_mod.c",
        "openssl/openssl/crypto/conf/conf_sap.c",
        "openssl/openssl/crypto/cpt_err.c",
        "openssl/openssl/crypto/cryptlib.c",
        "openssl/openssl/crypto/cversion.c",
        "openssl/openssl/crypto/des/cbc_cksm.c",
        "openssl/openssl/crypto/des/cbc_enc.c",
        "openssl/openssl/crypto/des/cfb64ede.c",
        "openssl/openssl/crypto/des/cfb64enc.c",
        "openssl/openssl/crypto/des/cfb_enc.c",
        "openssl/openssl/crypto/des/des_old.c",
        "openssl/openssl/crypto/des/des_old2.c",
        "openssl/openssl/crypto/des/ecb3_enc.c",
        "openssl/openssl/crypto/des/ecb_enc.c",
        "openssl/openssl/crypto/des/ede_cbcm_enc.c",
        "openssl/openssl/crypto/des/enc_read.c",
        "openssl/openssl/crypto/des/enc_writ.c",
        "openssl/openssl/crypto/des/fcrypt.c",
        "openssl/openssl/crypto/des/ofb64ede.c",
        "openssl/openssl/crypto/des/ofb64enc.c",
        "openssl/openssl/crypto/des/ofb_enc.c",
        "openssl/openssl/crypto/des/pcbc_enc.c",
        "openssl/openssl/crypto/des/qud_cksm.c",
        "openssl/openssl/crypto/des/rand_key.c",
        "openssl/openssl/crypto/des/read2pwd.c",
        "openssl/openssl/crypto/des/rpc_enc.c",
        "openssl/openssl/crypto/des/set_key.c",
        "openssl/openssl/crypto/des/str2key.c",
        "openssl/openssl/crypto/des/xcbc_enc.c",
        "openssl/openssl/crypto/dh/dh_ameth.c",
        "openssl/openssl/crypto/dh/dh_asn1.c",
        "openssl/openssl/crypto/dh/dh_check.c",
        "openssl/openssl/crypto/dh/dh_depr.c",
        "openssl/openssl/crypto/dh/dh_err.c",
        "openssl/openssl/crypto/dh/dh_gen.c",
        "openssl/openssl/crypto/dh/dh_key.c",
        "openssl/openssl/crypto/dh/dh_lib.c",
        "openssl/openssl/crypto/dh/dh_pmeth.c",
        "openssl/openssl/crypto/dh/dh_prn.c",
        "openssl/openssl/crypto/dsa/dsa_ameth.c",
        "openssl/openssl/crypto/dsa/dsa_asn1.c",
        "openssl/openssl/crypto/dsa/dsa_depr.c",
        "openssl/openssl/crypto/dsa/dsa_err.c",
        "openssl/openssl/crypto/dsa/dsa_gen.c",
        "openssl/openssl/crypto/dsa/dsa_key.c",
        "openssl/openssl/crypto/dsa/dsa_lib.c",
        "openssl/openssl/crypto/dsa/dsa_ossl.c",
        "openssl/openssl/crypto/dsa/dsa_pmeth.c",
        "openssl/openssl/crypto/dsa/dsa_prn.c",
        "openssl/openssl/crypto/dsa/dsa_sign.c",
        "openssl/openssl/crypto/dsa/dsa_vrf.c",
        "openssl/openssl/crypto/dso/dso_beos.c",
        "openssl/openssl/crypto/dso/dso_dl.c",
        "openssl/openssl/crypto/dso/dso_dlfcn.c",
        "openssl/openssl/crypto/dso/dso_err.c",
        "openssl/openssl/crypto/dso/dso_lib.c",
        "openssl/openssl/crypto/dso/dso_null.c",
        "openssl/openssl/crypto/dso/dso_openssl.c",
        "openssl/openssl/crypto/dso/dso_vms.c",
        "openssl/openssl/crypto/dso/dso_win32.c",
        "openssl/openssl/crypto/ebcdic.c",
        "openssl/openssl/crypto/ec/ec2_mult.c",
        "openssl/openssl/crypto/ec/ec2_oct.c",
        "openssl/openssl/crypto/ec/ec2_smpl.c",
        "openssl/openssl/crypto/ec/ec_ameth.c",
        "openssl/openssl/crypto/ec/ec_asn1.c",
        "openssl/openssl/crypto/ec/ec_check.c",
        "openssl/openssl/crypto/ec/ec_curve.c",
        "openssl/openssl/crypto/ec/ec_cvt.c",
        "openssl/openssl/crypto/ec/ec_err.c",
        "openssl/openssl/crypto/ec/ec_key.c",
        "openssl/openssl/crypto/ec/ec_lib.c",
        "openssl/openssl/crypto/ec/ec_mult.c",
        "openssl/openssl/crypto/ec/ec_oct.c",
        "openssl/openssl/crypto/ec/ec_pmeth.c",
        "openssl/openssl/crypto/ec/ec_print.c",
        "openssl/openssl/crypto/ec/eck_prn.c",
        "openssl/openssl/crypto/ec/ecp_mont.c",
        "openssl/openssl/crypto/ec/ecp_nist.c",
        "openssl/openssl/crypto/ec/ecp_nistp224.c",
        "openssl/openssl/crypto/ec/ecp_nistp256.c",
        "openssl/openssl/crypto/ec/ecp_nistp521.c",
        "openssl/openssl/crypto/ec/ecp_nistputil.c",
        "openssl/openssl/crypto/ec/ecp_oct.c",
        "openssl/openssl/crypto/ec/ecp_smpl.c",
        "openssl/openssl/crypto/ecdh/ech_err.c",
        "openssl/openssl/crypto/ecdh/ech_key.c",
        "openssl/openssl/crypto/ecdh/ech_lib.c",
        "openssl/openssl/crypto/ecdh/ech_ossl.c",
        "openssl/openssl/crypto/ecdsa/ecs_asn1.c",
        "openssl/openssl/crypto/ecdsa/ecs_err.c",
        "openssl/openssl/crypto/ecdsa/ecs_lib.c",
        "openssl/openssl/crypto/ecdsa/ecs_ossl.c",
        "openssl/openssl/crypto/ecdsa/ecs_sign.c",
        "openssl/openssl/crypto/ecdsa/ecs_vrf.c",
        "openssl/openssl/crypto/engine/eng_all.c",
        "openssl/openssl/crypto/engine/eng_cnf.c",
        "openssl/openssl/crypto/engine/eng_cryptodev.c",
        "openssl/openssl/crypto/engine/eng_ctrl.c",
        "openssl/openssl/crypto/engine/eng_dyn.c",
        "openssl/openssl/crypto/engine/eng_err.c",
        "openssl/openssl/crypto/engine/eng_fat.c",
        "openssl/openssl/crypto/engine/eng_init.c",
        "openssl/openssl/crypto/engine/eng_lib.c",
        "openssl/openssl/crypto/engine/eng_list.c",
        "openssl/openssl/crypto/engine/eng_openssl.c",
        "openssl/openssl/crypto/engine/eng_pkey.c",
        "openssl/openssl/crypto/engine/eng_rdrand.c",
        "openssl/openssl/crypto/engine/eng_rsax.c",
        "openssl/openssl/crypto/engine/eng_table.c",
        "openssl/openssl/crypto/engine/tb_asnmth.c",
        "openssl/openssl/crypto/engine/tb_cipher.c",
        "openssl/openssl/crypto/engine/tb_dh.c",
        "openssl/openssl/crypto/engine/tb_digest.c",
        "openssl/openssl/crypto/engine/tb_dsa.c",
        "openssl/openssl/crypto/engine/tb_ecdh.c",
        "openssl/openssl/crypto/engine/tb_ecdsa.c",
        "openssl/openssl/crypto/engine/tb_pkmeth.c",
        "openssl/openssl/crypto/engine/tb_rand.c",
        "openssl/openssl/crypto/engine/tb_rsa.c",
        "openssl/openssl/crypto/engine/tb_store.c",
        "openssl/openssl/crypto/err/err.c",
        "openssl/openssl/crypto/err/err_all.c",
        "openssl/openssl/crypto/err/err_prn.c",
        "openssl/openssl/crypto/evp/bio_b64.c",
        "openssl/openssl/crypto/evp/bio_enc.c",
        "openssl/openssl/crypto/evp/bio_md.c",
        "openssl/openssl/crypto/evp/bio_ok.c",
        "openssl/openssl/crypto/evp/c_all.c",
        "openssl/openssl/crypto/evp/c_allc.c",
        "openssl/openssl/crypto/evp/c_alld.c",
        "openssl/openssl/crypto/evp/digest.c",
        "openssl/openssl/crypto/evp/e_aes.c",
        "openssl/openssl/crypto/evp/e_aes_cbc_hmac_sha1.c",
        "openssl/openssl/crypto/evp/e_bf.c",
        "openssl/openssl/crypto/evp/e_camellia.c",
        "openssl/openssl/crypto/evp/e_cast.c",
        "openssl/openssl/crypto/evp/e_des.c",
        "openssl/openssl/crypto/evp/e_des3.c",
        "openssl/openssl/crypto/evp/e_idea.c",
        "openssl/openssl/crypto/evp/e_null.c",
        "openssl/openssl/crypto/evp/e_old.c",
        "openssl/openssl/crypto/evp/e_rc2.c",
        "openssl/openssl/crypto/evp/e_rc4.c",
        "openssl/openssl/crypto/evp/e_rc4_hmac_md5.c",
        "openssl/openssl/crypto/evp/e_rc5.c",
        "openssl/openssl/crypto/evp/e_seed.c",
        "openssl/openssl/crypto/evp/e_xcbc_d.c",
        "openssl/openssl/crypto/evp/encode.c",
        "openssl/openssl/crypto/evp/evp_acnf.c",
        "openssl/openssl/crypto/evp/evp_cnf.c",
        "openssl/openssl/crypto/evp/evp_enc.c",
        "openssl/openssl/crypto/evp/evp_err.c",
        "openssl/openssl/crypto/evp/evp_fips.c",
        "openssl/openssl/crypto/evp/evp_key.c",
        "openssl/openssl/crypto/evp/evp_lib.c",
        "openssl/openssl/crypto/evp/evp_pbe.c",
        "openssl/openssl/crypto/evp/evp_pkey.c",
        "openssl/openssl/crypto/evp/m_dss.c",
        "openssl/openssl/crypto/evp/m_dss1.c",
        "openssl/openssl/crypto/evp/m_ecdsa.c",
        "openssl/openssl/crypto/evp/m_md2.c",
        "openssl/openssl/crypto/evp/m_md4.c",
        "openssl/openssl/crypto/evp/m_md5.c",
        "openssl/openssl/crypto/evp/m_mdc2.c",
        "openssl/openssl/crypto/evp/m_null.c",
        "openssl/openssl/crypto/evp/m_ripemd.c",
        "openssl/openssl/crypto/evp/m_sha.c",
        "openssl/openssl/crypto/evp/m_sha1.c",
        "openssl/openssl/crypto/evp/m_sigver.c",
        "openssl/openssl/crypto/evp/m_wp.c",
        "openssl/openssl/crypto/evp/names.c",
        "openssl/openssl/crypto/evp/p5_crpt.c",
        "openssl/openssl/crypto/evp/p5_crpt2.c",
        "openssl/openssl/crypto/evp/p_dec.c",
        "openssl/openssl/crypto/evp/p_enc.c",
        "openssl/openssl/crypto/evp/p_lib.c",
        "openssl/openssl/crypto/evp/p_open.c",
        "openssl/openssl/crypto/evp/p_seal.c",
        "openssl/openssl/crypto/evp/p_sign.c",
        "openssl/openssl/crypto/evp/p_verify.c",
        "openssl/openssl/crypto/evp/pmeth_fn.c",
        "openssl/openssl/crypto/evp/pmeth_gn.c",
        "openssl/openssl/crypto/evp/pmeth_lib.c",
        "openssl/openssl/crypto/ex_data.c",
        "openssl/openssl/crypto/fips_ers.c",
        "openssl/openssl/crypto/hmac/hm_ameth.c",
        "openssl/openssl/crypto/hmac/hm_pmeth.c",
        "openssl/openssl/crypto/hmac/hmac.c",
        "openssl/openssl/crypto/idea/i_cbc.c",
        "openssl/openssl/crypto/idea/i_cfb64.c",
        "openssl/openssl/crypto/idea/i_ecb.c",
        "openssl/openssl/crypto/idea/i_ofb64.c",
        "openssl/openssl/crypto/idea/i_skey.c",
        "openssl/openssl/crypto/krb5/krb5_asn.c",
        "openssl/openssl/crypto/lhash/lh_stats.c",
        "openssl/openssl/crypto/lhash/lhash.c",
        "openssl/openssl/crypto/md2/md2_dgst.c",
        "openssl/openssl/crypto/md2/md2_one.c",
        "openssl/openssl/crypto/md4/md4_dgst.c",
        "openssl/openssl/crypto/md4/md4_one.c",
        "openssl/openssl/crypto/md5/md5_dgst.c",
        "openssl/openssl/crypto/md5/md5_one.c",
        "openssl/openssl/crypto/mdc2/mdc2_one.c",
        "openssl/openssl/crypto/mdc2/mdc2dgst.c",
        "openssl/openssl/crypto/mem.c",
        "openssl/openssl/crypto/mem_dbg.c",
        "openssl/openssl/crypto/modes/cbc128.c",
        "openssl/openssl/crypto/modes/ccm128.c",
        "openssl/openssl/crypto/modes/cfb128.c",
        "openssl/openssl/crypto/modes/ctr128.c",
        "openssl/openssl/crypto/modes/cts128.c",
        "openssl/openssl/crypto/modes/gcm128.c",
        "openssl/openssl/crypto/modes/ofb128.c",
        "openssl/openssl/crypto/modes/xts128.c",
        "openssl/openssl/crypto/o_dir.c",
        "openssl/openssl/crypto/o_fips.c",
        "openssl/openssl/crypto/o_init.c",
        "openssl/openssl/crypto/o_str.c",
        "openssl/openssl/crypto/o_time.c",
        "openssl/openssl/crypto/objects/o_names.c",
        "openssl/openssl/crypto/objects/obj_dat.c",
        "openssl/openssl/crypto/objects/obj_err.c",
        "openssl/openssl/crypto/objects/obj_lib.c",
        "openssl/openssl/crypto/objects/obj_xref.c",
        "openssl/openssl/crypto/ocsp/ocsp_asn.c",
        "openssl/openssl/crypto/ocsp/ocsp_cl.c",
        "openssl/openssl/crypto/ocsp/ocsp_err.c",
        "openssl/openssl/crypto/ocsp/ocsp_ext.c",
        "openssl/openssl/crypto/ocsp/ocsp_ht.c",
        "openssl/openssl/crypto/ocsp/ocsp_lib.c",
        "openssl/openssl/crypto/ocsp/ocsp_prn.c",
        "openssl/openssl/crypto/ocsp/ocsp_srv.c",
        "openssl/openssl/crypto/ocsp/ocsp_vfy.c",
        "openssl/openssl/crypto/pem/pem_all.c",
        "openssl/openssl/crypto/pem/pem_err.c",
        "openssl/openssl/crypto/pem/pem_info.c",
        "openssl/openssl/crypto/pem/pem_lib.c",
        "openssl/openssl/crypto/pem/pem_oth.c",
        "openssl/openssl/crypto/pem/pem_pk8.c",
        "openssl/openssl/crypto/pem/pem_pkey.c",
        "openssl/openssl/crypto/pem/pem_seal.c",
        "openssl/openssl/crypto/pem/pem_sign.c",
        "openssl/openssl/crypto/pem/pem_x509.c",
        "openssl/openssl/crypto/pem/pem_xaux.c",
        "openssl/openssl/crypto/pem/pvkfmt.c",
        "openssl/openssl/crypto/pkcs12/p12_add.c",
        "openssl/openssl/crypto/pkcs12/p12_asn.c",
        "openssl/openssl/crypto/pkcs12/p12_attr.c",
        "openssl/openssl/crypto/pkcs12/p12_crpt.c",
        "openssl/openssl/crypto/pkcs12/p12_crt.c",
        "openssl/openssl/crypto/pkcs12/p12_decr.c",
        "openssl/openssl/crypto/pkcs12/p12_init.c",
        "openssl/openssl/crypto/pkcs12/p12_key.c",
        "openssl/openssl/crypto/pkcs12/p12_kiss.c",
        "openssl/openssl/crypto/pkcs12/p12_mutl.c",
        "openssl/openssl/crypto/pkcs12/p12_npas.c",
        "openssl/openssl/crypto/pkcs12/p12_p8d.c",
        "openssl/openssl/crypto/pkcs12/p12_p8e.c",
        "openssl/openssl/crypto/pkcs12/p12_utl.c",
        "openssl/openssl/crypto/pkcs12/pk12err.c",
        "openssl/openssl/crypto/pkcs7/bio_pk7.c",
        "openssl/openssl/crypto/pkcs7/pk7_asn1.c",
        "openssl/openssl/crypto/pkcs7/pk7_attr.c",
        "openssl/openssl/crypto/pkcs7/pk7_doit.c",
        "openssl/openssl/crypto/pkcs7/pk7_lib.c",
        "openssl/openssl/crypto/pkcs7/pk7_mime.c",
        "openssl/openssl/crypto/pkcs7/pk7_smime.c",
        "openssl/openssl/crypto/pkcs7/pkcs7err.c",
        "openssl/openssl/crypto/pqueue/pqueue.c",
        "openssl/openssl/crypto/rand/md_rand.c",
        "openssl/openssl/crypto/rand/rand_egd.c",
        "openssl/openssl/crypto/rand/rand_err.c",
        "openssl/openssl/crypto/rand/rand_lib.c",
        "openssl/openssl/crypto/rand/rand_nw.c",
        "openssl/openssl/crypto/rand/rand_os2.c",
        "openssl/openssl/crypto/rand/rand_unix.c",
        "openssl/openssl/crypto/rand/rand_win.c",
        "openssl/openssl/crypto/rand/randfile.c",
        "openssl/openssl/crypto/rc2/rc2_cbc.c",
        "openssl/openssl/crypto/rc2/rc2_ecb.c",
        "openssl/openssl/crypto/rc2/rc2_skey.c",
        "openssl/openssl/crypto/rc2/rc2cfb64.c",
        "openssl/openssl/crypto/rc2/rc2ofb64.c",
        "openssl/openssl/crypto/rc4/rc4_utl.c",
        "openssl/openssl/crypto/ripemd/rmd_dgst.c",
        "openssl/openssl/crypto/ripemd/rmd_one.c",
        "openssl/openssl/crypto/rsa/rsa_ameth.c",
        "openssl/openssl/crypto/rsa/rsa_asn1.c",
        "openssl/openssl/crypto/rsa/rsa_chk.c",
        "openssl/openssl/crypto/rsa/rsa_crpt.c",
        "openssl/openssl/crypto/rsa/rsa_depr.c",
        "openssl/openssl/crypto/rsa/rsa_eay.c",
        "openssl/openssl/crypto/rsa/rsa_err.c",
        "openssl/openssl/crypto/rsa/rsa_gen.c",
        "openssl/openssl/crypto/rsa/rsa_lib.c",
        "openssl/openssl/crypto/rsa/rsa_none.c",
        "openssl/openssl/crypto/rsa/rsa_null.c",
        "openssl/openssl/crypto/rsa/rsa_oaep.c",
        "openssl/openssl/crypto/rsa/rsa_pk1.c",
        "openssl/openssl/crypto/rsa/rsa_pmeth.c",
        "openssl/openssl/crypto/rsa/rsa_prn.c",
        "openssl/openssl/crypto/rsa/rsa_pss.c",
        "openssl/openssl/crypto/rsa/rsa_saos.c",
        "openssl/openssl/crypto/rsa/rsa_sign.c",
        "openssl/openssl/crypto/rsa/rsa_ssl.c",
        "openssl/openssl/crypto/rsa/rsa_x931.c",
        "openssl/openssl/crypto/seed/seed.c",
        "openssl/openssl/crypto/seed/seed_cbc.c",
        "openssl/openssl/crypto/seed/seed_cfb.c",
        "openssl/openssl/crypto/seed/seed_ecb.c",
        "openssl/openssl/crypto/seed/seed_ofb.c",
        "openssl/openssl/crypto/sha/sha1_one.c",
        "openssl/openssl/crypto/sha/sha1dgst.c",
        "openssl/openssl/crypto/sha/sha256.c",
        "openssl/openssl/crypto/sha/sha512.c",
        "openssl/openssl/crypto/sha/sha_dgst.c",
        "openssl/openssl/crypto/sha/sha_one.c",
        "openssl/openssl/crypto/srp/srp_lib.c",
        "openssl/openssl/crypto/srp/srp_vfy.c",
        "openssl/openssl/crypto/stack/stack.c",
        "openssl/openssl/crypto/store/str_err.c",
        "openssl/openssl/crypto/store/str_lib.c",
        "openssl/openssl/crypto/store/str_mem.c",
        "openssl/openssl/crypto/store/str_meth.c",
        "openssl/openssl/crypto/ts/ts_asn1.c",
        "openssl/openssl/crypto/ts/ts_conf.c",
        "openssl/openssl/crypto/ts/ts_err.c",
        "openssl/openssl/crypto/ts/ts_lib.c",
        "openssl/openssl/crypto/ts/ts_req_print.c",
        "openssl/openssl/crypto/ts/ts_req_utils.c",
        "openssl/openssl/crypto/ts/ts_rsp_print.c",
        "openssl/openssl/crypto/ts/ts_rsp_sign.c",
        "openssl/openssl/crypto/ts/ts_rsp_utils.c",
        "openssl/openssl/crypto/ts/ts_rsp_verify.c",
        "openssl/openssl/crypto/ts/ts_verify_ctx.c",
        "openssl/openssl/crypto/txt_db/txt_db.c",
        "openssl/openssl/crypto/ui/ui_compat.c",
        "openssl/openssl/crypto/ui/ui_err.c",
        "openssl/openssl/crypto/ui/ui_lib.c",
        "openssl/openssl/crypto/ui/ui_openssl.c",
        "openssl/openssl/crypto/ui/ui_util.c",
        "openssl/openssl/crypto/uid.c",
        "openssl/openssl/crypto/whrlpool/wp_dgst.c",
        "openssl/openssl/crypto/x509/by_dir.c",
        "openssl/openssl/crypto/x509/by_file.c",
        "openssl/openssl/crypto/x509/x509_att.c",
        "openssl/openssl/crypto/x509/x509_cmp.c",
        "openssl/openssl/crypto/x509/x509_d2.c",
        "openssl/openssl/crypto/x509/x509_def.c",
        "openssl/openssl/crypto/x509/x509_err.c",
        "openssl/openssl/crypto/x509/x509_ext.c",
        "openssl/openssl/crypto/x509/x509_lu.c",
        "openssl/openssl/crypto/x509/x509_obj.c",
        "openssl/openssl/crypto/x509/x509_r2x.c",
        "openssl/openssl/crypto/x509/x509_req.c",
        "openssl/openssl/crypto/x509/x509_set.c",
        "openssl/openssl/crypto/x509/x509_trs.c",
        "openssl/openssl/crypto/x509/x509_txt.c",
        "openssl/openssl/crypto/x509/x509_v3.c",
        "openssl/openssl/crypto/x509/x509_vfy.c",
        "openssl/openssl/crypto/x509/x509_vpm.c",
        "openssl/openssl/crypto/x509/x509cset.c",
        "openssl/openssl/crypto/x509/x509name.c",
        "openssl/openssl/crypto/x509/x509rset.c",
        "openssl/openssl/crypto/x509/x509spki.c",
        "openssl/openssl/crypto/x509/x509type.c",
        "openssl/openssl/crypto/x509/x_all.c",
        "openssl/openssl/crypto/x509v3/pcy_cache.c",
        "openssl/openssl/crypto/x509v3/pcy_data.c",
        "openssl/openssl/crypto/x509v3/pcy_lib.c",
        "openssl/openssl/crypto/x509v3/pcy_map.c",
        "openssl/openssl/crypto/x509v3/pcy_node.c",
        "openssl/openssl/crypto/x509v3/pcy_tree.c",
        "openssl/openssl/crypto/x509v3/v3_addr.c",
        "openssl/openssl/crypto/x509v3/v3_akey.c",
        "openssl/openssl/crypto/x509v3/v3_akeya.c",
        "openssl/openssl/crypto/x509v3/v3_alt.c",
        "openssl/openssl/crypto/x509v3/v3_asid.c",
        "openssl/openssl/crypto/x509v3/v3_bcons.c",
        "openssl/openssl/crypto/x509v3/v3_bitst.c",
        "openssl/openssl/crypto/x509v3/v3_conf.c",
        "openssl/openssl/crypto/x509v3/v3_cpols.c",
        "openssl/openssl/crypto/x509v3/v3_crld.c",
        "openssl/openssl/crypto/x509v3/v3_enum.c",
        "openssl/openssl/crypto/x509v3/v3_extku.c",
        "openssl/openssl/crypto/x509v3/v3_genn.c",
        "openssl/openssl/crypto/x509v3/v3_ia5.c",
        "openssl/openssl/crypto/x509v3/v3_info.c",
        "openssl/openssl/crypto/x509v3/v3_int.c",
        "openssl/openssl/crypto/x509v3/v3_lib.c",
        "openssl/openssl/crypto/x509v3/v3_ncons.c",
        "openssl/openssl/crypto/x509v3/v3_ocsp.c",
        "openssl/openssl/crypto/x509v3/v3_pci.c",
        "openssl/openssl/crypto/x509v3/v3_pcia.c",
        "openssl/openssl/crypto/x509v3/v3_pcons.c",
        "openssl/openssl/crypto/x509v3/v3_pku.c",
        "openssl/openssl/crypto/x509v3/v3_pmaps.c",
        "openssl/openssl/crypto/x509v3/v3_prn.c",
        "openssl/openssl/crypto/x509v3/v3_purp.c",
        "openssl/openssl/crypto/x509v3/v3_skey.c",
        "openssl/openssl/crypto/x509v3/v3_sxnet.c",
        "openssl/openssl/crypto/x509v3/v3_utl.c",
        "openssl/openssl/crypto/x509v3/v3err.c",
        "openssl/openssl/engines/e_4758cca.c",
        "openssl/openssl/engines/e_aep.c",
        "openssl/openssl/engines/e_atalla.c",
        "openssl/openssl/engines/e_capi.c",
        "openssl/openssl/engines/e_chil.c",
        "openssl/openssl/engines/e_cswift.c",
        "openssl/openssl/engines/e_gmp.c",
        "openssl/openssl/engines/e_nuron.c",
        "openssl/openssl/engines/e_sureware.c",
        "openssl/openssl/engines/e_ubsec.c"
      ],
      "sources/": [
        ["exclude", "md2/.*$"],
        ["exclude", "store/.*$"]
      ],
      "conditions": [
        ["openssl_enable_asm!=1", {
           "defines": [
            "OPENSSL_NO_ASM"
           ],
           "sources": [
            "openssl/openssl/crypto/aes/aes_cbc.c",
            "openssl/openssl/crypto/aes/aes_core.c",
            "openssl/openssl/crypto/bf/bf_enc.c",
            "openssl/openssl/crypto/bn/bn_asm.c",
            "openssl/openssl/crypto/cast/c_enc.c",
            "openssl/openssl/crypto/camellia/camellia.c",
            "openssl/openssl/crypto/camellia/cmll_cbc.c",
            "openssl/openssl/crypto/camellia/cmll_misc.c",
            "openssl/openssl/crypto/des/des_enc.c",
            "openssl/openssl/crypto/des/fcrypt_b.c",
            "openssl/openssl/crypto/mem_clr.c",
            "openssl/openssl/crypto/rc4/rc4_enc.c",
            "openssl/openssl/crypto/rc4/rc4_skey.c",
            "openssl/openssl/crypto/whrlpool/wp_block.c"
           ]
        }, {
            "defines": [
            "AES_ASM",
            "BF_ASM",
            "BNCO_ASM",
            "BN_ASM",
            "CPUID_ASM",
            "DES_ASM",
            "LIB_BN_ASM",
            "OPENSSL_BN_ASM",
            "OPENSSL_CPUID_OBJ",
            "RIP_ASM",
            "WHIRLPOOL_ASM",
            "WP_ASM"
          ],
            "conditions": [
            ["OS!='win' and OS!='mac' and target_arch=='ia32'", {
                  "sources": [
                "asm/x86-elf-gas/aes/aes-586.s",
                "asm/x86-elf-gas/aes/aesni-x86.s",
                "asm/x86-elf-gas/bf/bf-686.s",
                "asm/x86-elf-gas/bn/x86-mont.s",
                "asm/x86-elf-gas/bn/x86.s",
                "asm/x86-elf-gas/camellia/cmll-x86.s",
                "asm/x86-elf-gas/cast/cast-586.s",
                "asm/x86-elf-gas/des/crypt586.s",
                "asm/x86-elf-gas/des/des-586.s",
                "asm/x86-elf-gas/md5/md5-586.s",
                "asm/x86-elf-gas/rc4/rc4-586.s",
                "asm/x86-elf-gas/rc5/rc5-586.s",
                "asm/x86-elf-gas/ripemd/rmd-586.s",
                "asm/x86-elf-gas/sha/sha1-586.s",
                "asm/x86-elf-gas/sha/sha256-586.s",
                "asm/x86-elf-gas/sha/sha512-586.s",
                "asm/x86-elf-gas/whrlpool/wp-mmx.s",
                "asm/x86-elf-gas/x86cpuid.s",
                "openssl/openssl/crypto/whrlpool/wp_block.c"
              ]
            }],
            ["OS!='win' and OS!='mac' and target_arch=='x64'",
                {
                  "sources": [
                "asm/x64-elf-gas/aes/aes-x86_64.s",
                "asm/x64-elf-gas/aes/aesni-x86_64.s",
                "asm/x64-elf-gas/aes/aesni-sha1-x86_64.s",
                "asm/x64-elf-gas/bn/modexp512-x86_64.s",
                "asm/x64-elf-gas/bn/x86_64-mont.s",
                "asm/x64-elf-gas/camellia/cmll-x86_64.s",
                "asm/x64-elf-gas/md5/md5-x86_64.s",
                "asm/x64-elf-gas/rc4/rc4-x86_64.s",
                "asm/x64-elf-gas/rc4/rc4-md5-x86_64.s",
                "asm/x64-elf-gas/sha/sha1-x86_64.s",
                "asm/x64-elf-gas/sha/sha512-x86_64.s",
                "asm/x64-elf-gas/whrlpool/wp-x86_64.s",
                "asm/x64-elf-gas/x86_64cpuid.s",
                #Non - generated asm
                "openssl/openssl/crypto/bn/asm/x86_64-gcc.c",
                #No asm available
                "openssl/openssl/crypto/bf/bf_enc.c",
                "openssl/openssl/crypto/cast/c_enc.c",
                "openssl/openssl/crypto/camellia/cmll_misc.c",
                "openssl/openssl/crypto/des/des_enc.c",
                "openssl/openssl/crypto/des/fcrypt_b.c"
              ]
            }],
            ["OS=='mac' and target_arch=='ia32'", {
                  "sources": [
                "asm/x86-macosx-gas/aes/aes-586.s",
                "asm/x86-macosx-gas/aes/aesni-x86.s",
                "asm/x86-macosx-gas/bf/bf-686.s",
                "asm/x86-macosx-gas/bn/x86-mont.s",
                "asm/x86-macosx-gas/bn/x86.s",
                "asm/x86-macosx-gas/camellia/cmll-x86.s",
                "asm/x86-macosx-gas/cast/cast-586.s",
                "asm/x86-macosx-gas/des/crypt586.s",
                "asm/x86-macosx-gas/des/des-586.s",
                "asm/x86-macosx-gas/md5/md5-586.s",
                "asm/x86-macosx-gas/rc4/rc4-586.s",
                "asm/x86-macosx-gas/rc5/rc5-586.s",
                "asm/x86-macosx-gas/ripemd/rmd-586.s",
                "asm/x86-macosx-gas/sha/sha1-586.s",
                "asm/x86-macosx-gas/sha/sha256-586.s",
                "asm/x86-macosx-gas/sha/sha512-586.s",
                "asm/x86-macosx-gas/whrlpool/wp-mmx.s",
                "asm/x86-macosx-gas/x86cpuid.s",
                "openssl/openssl/crypto/whrlpool/wp_block.c"
              ]
            }],
            ["OS=='mac' and target_arch=='x64'", {
                  "sources": [
                "asm/x64-macosx-gas/aes/aes-x86_64.s",
                "asm/x64-macosx-gas/aes/aesni-x86_64.s",
                "asm/x64-macosx-gas/aes/aesni-sha1-x86_64.s",
                "asm/x64-macosx-gas/bn/modexp512-x86_64.s",
                "asm/x64-macosx-gas/bn/x86_64-mont.s",
                "asm/x64-macosx-gas/camellia/cmll-x86_64.s",
                "asm/x64-macosx-gas/md5/md5-x86_64.s",
                "asm/x64-macosx-gas/rc4/rc4-x86_64.s",
                "asm/x64-macosx-gas/rc4/rc4-md5-x86_64.s",
                "asm/x64-macosx-gas/sha/sha1-x86_64.s",
                "asm/x64-macosx-gas/sha/sha512-x86_64.s",
                "asm/x64-macosx-gas/whrlpool/wp-x86_64.s",
                "asm/x64-macosx-gas/x86_64cpuid.s",
                #Non - generated asm
                "openssl/openssl/crypto/bn/asm/x86_64-gcc.c",
                #No asm available
                "openssl/openssl/crypto/bf/bf_enc.c",
                "openssl/openssl/crypto/cast/c_enc.c",
                "openssl/openssl/crypto/camellia/cmll_misc.c",
                "openssl/openssl/crypto/des/des_enc.c",
                "openssl/openssl/crypto/des/fcrypt_b.c"
              ]
            }],
            ["OS=='win' and target_arch=='ia32'", {
                  "sources": [
                "asm/x86-win32-masm/aes/aes-586.asm",
                "asm/x86-win32-masm/aes/aesni-x86.asm",
                "asm/x86-win32-masm/bf/bf-686.asm",
                "asm/x86-win32-masm/bn/x86-mont.asm",
                "asm/x86-win32-masm/bn/x86.asm",
                "asm/x86-win32-masm/camellia/cmll-x86.asm",
                "asm/x86-win32-masm/cast/cast-586.asm",
                "asm/x86-win32-masm/des/crypt586.asm",
                "asm/x86-win32-masm/des/des-586.asm",
                "asm/x86-win32-masm/md5/md5-586.asm",
                "asm/x86-win32-masm/rc4/rc4-586.asm",
                "asm/x86-win32-masm/rc5/rc5-586.asm",
                "asm/x86-win32-masm/ripemd/rmd-586.asm",
                "asm/x86-win32-masm/sha/sha1-586.asm",
                "asm/x86-win32-masm/sha/sha256-586.asm",
                "asm/x86-win32-masm/sha/sha512-586.asm",
                "asm/x86-win32-masm/whrlpool/wp-mmx.asm",
                "asm/x86-win32-masm/x86cpuid.asm",
                "openssl/openssl/crypto/whrlpool/wp_block.c"
              ],
                  "rules": [
                    {
                      "rule_name": "Assemble",
                      "extension": "asm",
                      "inputs": [],
                      "outputs": [
                    "<(INTERMEDIATE_DIR)/<(RULE_INPUT_ROOT).obj",
                  ],
                      "action": [
                    "ml.exe",
                    "/Zi",
                    "/safeseh",
                    "/Fo", "<(INTERMEDIATE_DIR)/<(RULE_INPUT_ROOT).obj",
                    "/c", "<(RULE_INPUT_PATH)",
                  ],
                      "process_outputs_as_sources": 0,
                      "message": "Assembling <(RULE_INPUT_PATH) to <(INTERMEDIATE_DIR)/<(RULE_INPUT_ROOT).obj.",
                }
              ]
            }],
            ["OS=='win' and target_arch=='x64'",
                {
                  "sources": [
                "asm/x64-win32-masm/aes/aes-x86_64.asm",
                "asm/x64-win32-masm/aes/aesni-x86_64.asm",
                "asm/x64-win32-masm/aes/aesni-sha1-x86_64.asm",
                "asm/x64-win32-masm/bn/modexp512-x86_64.asm",
                "asm/x64-win32-masm/bn/x86_64-mont.asm",
                "asm/x64-win32-masm/camellia/cmll-x86_64.asm",
                "asm/x64-win32-masm/md5/md5-x86_64.asm",
                "asm/x64-win32-masm/rc4/rc4-x86_64.asm",
                "asm/x64-win32-masm/rc4/rc4-md5-x86_64.asm",
                "asm/x64-win32-masm/sha/sha1-x86_64.asm",
                "asm/x64-win32-masm/sha/sha512-x86_64.asm",
                "asm/x64-win32-masm/whrlpool/wp-x86_64.asm",
                "asm/x64-win32-masm/x86_64cpuid.asm",
                #Non - generated asm
                "openssl/openssl/crypto/bn/asm/x86_64-win32-masm.asm",
                #No asm available
                "openssl/openssl/crypto/bf/bf_enc.c",
                "openssl/openssl/crypto/cast/c_enc.c",
                "openssl/openssl/crypto/camellia/cmll_misc.c",
                "openssl/openssl/crypto/des/des_enc.c",
                "openssl/openssl/crypto/des/fcrypt_b.c"
              ],
                  "rules": [
                    {
                      "rule_name": "Assemble",
                      "extension": "asm",
                      "inputs": [],
                      "outputs": [
                    "<(INTERMEDIATE_DIR)/<(RULE_INPUT_ROOT).obj",
                  ],
                      "action": [
                    "ml64.exe",
                    "/Zi",
                    "/Fo", "<(INTERMEDIATE_DIR)/<(RULE_INPUT_ROOT).obj",
                    "/c", "<(RULE_INPUT_PATH)",
                  ],
                      "process_outputs_as_sources": 0,
                      "message": "Assembling <(RULE_INPUT_PATH) to <(INTERMEDIATE_DIR)/<(RULE_INPUT_ROOT).obj.",
                }
              ]
            }]
          ]
        }],
        ["OS=='win'", {
            "defines": [
            "MK1MF_BUILD",
            "WIN32_LEAN_AND_MEAN"
          ],
            "link_settings": {
              "libraries": [
              "-lgdi32.lib",
              "-luser32.lib",
              "-lwsock32.lib",
            ],
              "conditions": [
                ["_type=='shared_library'", {
                    "libraries": [
                        "-ladvapi32.lib"
                    ]
                }]
            ]
            }
        }, {
            "defines": [
            "TERMIOS",
          ],
            "cflags": [
            "-Wno-missing-field-initializers"
          ],
        }],
        ["is_clang==1 or gcc_version>=43", {
            "cflags": [
            "-Wno-old-style-declaration"
           ],
        }],
        ["OS=='solaris'", {
            "defines": [
            "__EXTENSIONS__"
           ],
        }],
        ["target_arch=='arm'", {
            "sources": [
            "openssl/openssl/crypto/armcap.c"
          ],
        }],
      ],
    },
  ]
}
